<?php

namespace FiloBlu\Storelocator\Model\Plugin\Rma;

use FiloBlu\Rma\Model\Rma\Status\HistoryFactory;

class RmaEmailManagement
{
    /**
     * @var \FiloBlu\Storelocator\Helper\Data
     */
    protected $helper;
    /**
     * @var HistoryFactory
     */
    protected $historyFactory;

    public function __construct(
        \FiloBlu\Storelocator\Helper\Data $helper,
        HistoryFactory $historyFactory
    )
    {
        $this->helper = $helper;
        $this->historyFactory = $historyFactory;
    }

    public function  aroundSendRmaEmail(\FiloBlu\Rma\Model\RmaEmailManagment $subject, callable $proceed, $rmaEntityId = null, $status = null) {

        if (!$this->helper->getReturnToStoreEnabled()) {
            return $proceed($rmaEntityId, $status);
        }

        if ($this->helper->getReturnToStoreEnabled() && $this->helper->getUseStandardRmaMailFlow()) {
            return $proceed($rmaEntityId, $status);
        }

        if ($status !== 'received') {
            return $proceed($rmaEntityId, $status);
        }

        $path = \FiloBlu\Rma\Model\RmaEmailManagment::XML_PATH_STATE_PREFIX . "_$status";
        if($status == "authorized"){
            $path = \FiloBlu\Rma\Model\RmaEmailManagment::XML_PATH_STATE_PREFIX . "_auth";
        }

        if($status == 'pending'){
            $path = \FiloBlu\Rma\Model\RmaEmailManagment::XML_PATH_STATE_PREFIX ;
        }

        $statusHistory = $this->historyFactory->create();
        $statusHistory->setRmaEntityId($rmaEntityId);

        return $statusHistory->sendRmaEmail($path);
    }
}